<template>
<div class="left-panels">
  <div class="left-side-bar">
    <div class="strip">
      <!-- Plugin -->
      <div v-for="item in pluginsToolBar" :key="item.id">
        <div class="menu-item" v-b-tooltip.right.hover :title="item.label"
          :class="{ 'active': item.componentName && visiblePanel == item.componentName }"
          v-if="item.isActive"
          @click="menuPluginActivated(item)">
          <b-icon v-if="item.configuration.icon" :icon="item.configuration.icon"></b-icon>
        </div>
      </div>
      <!-- Menus Fixes -->
      <div v-for="item in leftSideBarItems" :key="item.label">
        <div class="menu-item edit-menu" v-b-tooltip.right.hover :title="item.label"
          :class="{ 'active': item.panel && visiblePanel == item.panel }"
          v-if="(item.editionOnly==false || contextService.isEditionActive)
                    && (item.plugin==undefined || pluginService.isActive(item.panel))"
                    @click="menuActivated(item)">
                    <b-icon v-if="item.icon" :icon="item.icon"></b-icon>
        </div>
      </div>
    </div>
  </div>
  <transition name="component-fade" mode="out-in">
        <div class= "panel-container" v-if="visiblePanel != ''">
            <component
            v-bind:is="visiblePanel" :plugin="visiblePluginPanel"></component>
        </div>

  </transition>
</div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Component from 'vue-class-component';
import LayerListPanel from '@/components/layers/LayerListPanel.vue';
import LegendPlugin from '@/components/plugins/legend/LegendPlugin.vue';
import PluginListPanel from '@/components/plugins/PluginListPanel.vue';
import SettingsPanel from '@/components/settings/SettingsPanel.vue';
import Plugin from '@/models/plugin/Plugin';
import FeatureInfosPanel from '@/components/map/FeatureInfosPanel.vue';
import PrintPanelPlugin from '@/components/plugins/print/PrintPanelPlugin.vue';
import { EventBus, EVENTS } from '@/services/EventBus';
import { PluginLocation } from '@/models/plugin/PluginLocation';
import BaseComponent from './BaseComponent';
import PermalinkPlugin from './plugins/PermalinkPlugin.vue';
import StatsPlugin from './plugins/StatsPlugin.vue';

@Component({
  props: {},
  components: {
    LayerListPanel,
    PluginListPanel,
    LegendPlugin,
    FeatureInfosPanel,
    SettingsPanel,
    PrintPanelPlugin,
    PermalinkPlugin,
    StatsPlugin,
  },
})
export default class LeftSideBar extends BaseComponent {
  visiblePanel='';

  visiblePluginPanel:Plugin|null=null;

  pluginsToolBar:Plugin[]=[];

  leftSideBarItems = [
    {
      icon: 'gear',
      label: 'Réglages',
      editionOnly: true,
      panel: SettingsPanel.ID,
    },
    {
      icon: 'puzzle',
      label: 'Modules',
      editionOnly: true,
      panel: PluginListPanel.ID,
    },
  ];

  created() {
    this.pluginsToolBar = this.pluginService.plugins.filter(
      (x:Plugin) => x.configuration.position === PluginLocation.LeftToolBar,
    );
  }

  mounted() {
    EventBus.$on(EVENTS.OPEN_LEFT_SIDE_MENU, (menu:any) => this.openMenu(menu));
    EventBus.$on(EVENTS.SELECT_FEATURE, (features:any) => this.onSelectFeature(features));
  }

  onSelectFeature(features:any) {
    if (this.pluginService.isActive(FeatureInfosPanel.ID)) {
      this.openMenu(FeatureInfosPanel.ID);
    }
  }

  openMenu(menu:string) {
    this.visiblePanel = menu;
  }

  menuActivated(item:any) {
    console.log(item);
    if (item.panel && this.visiblePanel !== item.panel) {
      this.visiblePanel = item.panel;
      this.visiblePluginPanel = null;
    } else {
      this.visiblePanel = '';
      this.visiblePluginPanel = null;
    }
  }

  menuPluginActivated(item:Plugin) {
    console.log(item);
    if (item.componentName && this.visiblePanel !== item.componentName) {
      this.visiblePanel = item.componentName;
      this.visiblePluginPanel = item;
    } else {
      this.visiblePanel = '';
      this.visiblePluginPanel = null;
    }
  }
}
</script>
<style scoped lang="less">
@import "../styles/variables.less";

.component-fade-enter-active{
  transition: all .3s cubic-bezier(1.0, 0.5, 0.8, 1.0);
}
.component-fade-leave-active {
  transition: all .3s cubic-bezier(1.0, 0.5, 0.8, 1.0);
}
.component-fade-enter, .component-fade-leave-to{
  transform: translateX(-100%);
}
.left-side-bar {
  pointer-events: auto;
  height: 100%;
  top:0px;
  width: 50px;
  background-color: white;
  border-right: 1px solid @grey;
  z-index: 1;
}
.strip{
  position:relative;
  width: 100%;
  height: 100%;
}
.left-panels{
  display: flex;
  width: auto;
  height: 100%;
}

.panel-container{
  width:30vw;
  min-width: 280px;
  border-radius: 0px;
  box-shadow: 0 24px 38px 3px rgba(0, 0, 0, 0.14), 0 9px 46px 8px rgba(0, 0, 0, 0.12), 0 11px 15px -7px rgba(0, 0, 0, 0.20);
  transition: all 0.3s cubic-bezier(.25,.8,.25,1);
  background-color: white;
  pointer-events: auto;
}

.menu-item{
  font-size: 25px;
  cursor: pointer;
  text-align: center;
  border-bottom: 1px solid @grey;
  color: @first;
}

.edit-menu{
  background-color: @light-first;
  border: 1px solid @grey;
}

.menu-item:hover {
  background-color: @light-first;
}
.active{
    background-color: rgb(214, 214, 214);
    border-left: 4px solid @second;
}
</style>
